<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>ruby2</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
</head>
<body>
<h3 id="control-flow">Control Flow</h3>
<p><strong>Objectives</strong> * If Statements * Each Loops * While Loops * Exercises!</p>
<h2 id="quick-review-of-expressions">Quick Review of Expressions</h2>
<p>What’s the difference?</p>
<pre><code>x = 5
x == 5</code></pre>
<p>Control flow uses <strong>boolean expressions</strong> to determine which code path to take. Some basic control flow statements are below.</p>
<p><strong>We can make decisions! Add logic to our code</strong></p>
<pre><code>if something
  do something
end</code></pre>
<p>So let’s look a super basic example</p>
<pre><code>puts &quot;Hello, what&#39;s your name? &quot;
name = gets.chomp
puts &quot;Hello, #{name}&quot;
if name == &#39;Colt&#39;
  puts &quot;What a great name! &quot;
end</code></pre>
<p>Now let’s add <strong>an else condition</strong></p>
<pre><code>puts &quot;Hello, what&#39;s your name? &quot;
name = gets.chomp
puts &quot;Hello, #{name}&quot;
if name == &#39;Colt&#39;
  puts &quot;What a great name! &quot;
else
  puts &quot;That&#39;s a pretty good name too!&quot;
end
</code></pre>
<p><strong>Open teacher.rb and have student walk me through it</strong></p>
<h3 id="elsif-statements"><strong>Elsif Statements</strong></h3>
<pre><code>num = 20
average = 50

if num &lt; average
  puts &quot;#{num} is below average&quot;
elsif num &gt; average
  puts  &quot;#{num} is above average&quot;
else
  puts  &quot;#{num} is exactly average&quot;
end
</code></pre>
<p>Since ruby is all about being human readable. It also allows us to do one line control flow statements.</p>
<pre><code>num = 10
max = 5

# Max is now 10
max = num if num &gt; max</code></pre>
<p>Also, since ruby is human readable, control flow statements generally have an opposite. For if, the opposite is <code>unless</code></p>
<pre><code>num = 1
min = 5

# Min is now 1
min = num unless num &gt; min</code></pre>
<p>Typically you use the control flow statements that sounds most natural in english.</p>
<p><strong>FIST TO FIVE</strong></p>
<h3 id="exercise">Exercise</h3>
<p>Write a calculator program that takes a number, an operation +,-,/,*, then another number. The program should be able to handle decimal numbers. Below is sample output:</p>
<pre><code>Enter a number, a +,-,/,*, then another number.
7
/ 
2
Result: 3.5</code></pre>
<h2 id="loops">Loops</h2>
<p>Loops are essential to programming. They allow us to repeat an operation many times. Typically, execution of a loop lasts as long as a certain value holds true or as long as a set of data is being iterated over. Below is an example of printing the values from 0 to 10 done using many different methods. Note that 0..10 is a Range type, which was discussed earlier.</p>
<p><strong>Times do loops</strong></p>
<pre><code>9.times do
  puts &quot;HELLO&quot;
end</code></pre>
<p><strong>For Loops</strong></p>
<pre><code>for i in 0..10
  puts &quot;The value of i is now #{i}&quot;
end</code></pre>
<pre><code>## Exercise: 99 bottles of beer
count = 99
while count &gt; 0
  puts &quot;#{count} bottles of beer on the wall&quot;
  count = count -1
  puts &quot;Take one down, pass it around #{count} bottles of beer on the wall&quot;
end

</code></pre>
<h1 id="iteration-using-a-block">Iteration using a block</h1>
<p>(0..10).each do |i| puts “The value of i is now #{i}” end</p>
<pre><code></code></pre>
<h1 id="a-more-condensed-way-to-iterate-using-a-block.">A more condensed way to iterate using a block.</h1>
<p>(0..10).each { |i| puts “The value of i is now #{i}” }</p>
<pre><code></code></pre>
<h1 id="iterating-with-a-while-loop">Iterating with a while loop</h1>
<p>i = 0 num = 10</p>
<p>while i &lt;= num do puts “The value of i is now #{i}” i += 1 end</p>
<pre><code>## While Loops
</code></pre>
<p>command = ’’</p>
<p>while command != ‘bye’ puts command command = gets.chomp end</p>
<p>puts ‘Come again soon!’</p>
<pre><code></code></pre>
<h1 id="iterating-until-a-value-is-true">Iterating until a value is true</h1>
<p>i = 0 num = 10</p>
<p>until i &gt; num puts “The value of i is now #{i}” i += 1 end</p>
<pre><code>
### Break
Break is a keyword that stops iteration of a loop.  In the example below, if i is equal to 6, then break is called. The output of the program will be 1 4 (each on separate lines).
</code></pre>
<p>arr = [1,4,6,9,24] for i in arr break if i == 6 puts i end</p>
<pre><code>



***

### Exercises
#### Average
Given an array of numbers, find the average value.  You can write any array you like into your code.  Below is example output:</code></pre>
<p>The average of [1, 4] is: 2.5</p>
<pre><code>
#### Sum
Write a program that asks the user for a number, then prints the sum of all the numbers between 0 and n incluse.  For example if the user enters 5, the program should sum 1 + 2 + 3 + 4 + 5 = 15.  Sample output is below:
</code></pre>
<p>Enter a number, N. The sum of 0 to N will be printed. 2 3</p>
<pre><code></code></pre>
<p>Enter a number, N. The sum of 0 to N will be printed. 5 15</p>
<pre><code>
***

# Appendix - Programs from Study hall
The programs below were used as in class exercises during the study hall.  They are added here for reference.

## Introduction
Write a program that introduces yourself to your neighbor.  The program should first ask your neighbor for his or her name and ask how many prework assignments they have completed.  Your program will then print the information back to the user along with a fun fact about yourself.  The output should look like this:
</code></pre>
<p>Hello, Jordan. I’m Tim. Nice to meet you. I see you have completed 14 assignments. I have completed 10 assignments" In my free time, I enjoy playing ultimate frisbee."</p>
<pre><code>### Solution
</code></pre>
<p>#!/usr/bin/env ruby</p>
<h1 id="saving-my-friends-name">Saving my friends name</h1>
<p>puts “Hello, what is your name?” friends_name = gets.chomp</p>
<h1 id="saving-the-number-of-completed-assignments">Saving the number of completed assignments</h1>
<p>puts “How many prework assignments have you completed?” completed_assignments = gets.chomp</p>
<h1 id="putting-to-stdout">Putting to STDOUT</h1>
<p>puts “Hello, #{friends_name}. I’m Tim. Nice to meet you” puts “I see you have completed #{completed_assignments} assignments. I have completed 1 assignment” puts “In my free time, I enjoy playing ultimate frisbee”</p>
<pre><code>
## Odd Or Even
Write a program that decides if a number is odd or even.

### Solution</code></pre>
<p>#!/usr/bin/env ruby</p>
<p>puts “Please enter a number” num = gets.to_i</p>
<p>if num % 2 == 0 puts “#{num} is even” else puts “#{num} is odd” end</p>
<pre><code>
## Reverse a Word
Given a word from the user.  Reverse the word and print it back to the user.

### Solution
</code></pre>
<p>#!/usr/bin/env ruby</p>
<p>puts “Enter a string to reverse” puts gets.chomp.reverse</p>
<pre><code>
## Calculator
Write a simple calculator program.  It should take as input, a number [enter], a + or - sign [enter], then another number.  The expressionw should then be evaluated and displayed to the user.  Below is sample input
</code></pre>
<p>Enter a number, a + or - sign, then another number 5 - 3 Result: 2</p>
<pre><code>
### Solution</code></pre>
<p>#!/usr/bin/env ruby</p>
<h1 id="a-calculator-program-that-only-understands-addition-and-subtraction">A calculator program that only understands addition and subtraction</h1>
<p>puts “Enter a number, a + or - sign, then another number”</p>
<h1 id="getting-our-input.-the-program-only-supports-simple-2-term-expressions">Getting our input. The program only supports simple 2 term expressions</h1>
<p>num1 = gets.to_i</p>
<p>sign = gets.chomp</p>
<p>num2 = gets.to_i</p>
<p>if sign == “+” puts “Result: #{num1 + num2}” elsif sign == “-” puts “Result: #{num1 - num2}” else puts “Please re-read the instructions” end</p>
<pre><code>
## Find Max
Find the maximum value in a array.

### Solution
</code></pre>
<p>#!/usr/bin/env ruby</p>
<p>arr = [1,3,9,5,34,99,20,-35,9]</p>
<p>max = arr[0]</p>
<p>arr.each do |i| if i &gt; max max = i end end</p>
<p>puts “The maximum value in the array is #{max}”</p>
<pre><code>
## Palindrome
Write a program that decides if a word entered by the user is a palindrome.  A palindrome is a word that is the same when spelled forward or in reverse.  For example, wow is a palindrome.  It is the same string when reversed.

### Solution</code></pre>
<p>#!/usr/bin/env ruby</p>
<p>puts “Enter a word. We’ll see if it’s a palindrome” word = gets.chomp</p>
<p>if word == word.reverse puts “#{word} is a palindrome” else puts “#{word} is NOT a palindrome” end ```</p>
</body>
</html>
